import { Connection } from '@workbench-stack/extension-api';
import { ITextFileService, ICodeEditorService, IModelService, ICommonEditor } from '@workbench-stack/core';
import { MainThreadTextEditor } from './client-editor';
export declare class MainThreadDocumentsAndEditors {
    private modelService;
    private textFileService;
    private serverProxy;
    private _deltaInited;
    private _currentDelta;
    private _updates;
    private _documents;
    private subscriptions;
    private proxy;
    private _textEditors;
    onTextEditorAdd: import("rxjs").Observable<unknown>;
    onTextEditorRemove: import("rxjs").Observable<unknown>;
    onDocumentAdd: import("rxjs").Observable<unknown>;
    onDocumentRemove: import("rxjs").Observable<unknown>;
    constructor(connection: Connection, modelService: IModelService, codeEditorService: ICodeEditorService, textFileService: ITextFileService);
    private _onDelta;
    private _toModelAddData;
    private _toTextEditorAddData;
    private _findEditorPosition;
    findTextEditorIdFor(editor: ICommonEditor): string | undefined;
    getEditor(id: string): MainThreadTextEditor;
    unsubscribe(): void;
}
